var Cus09900_AnaliseComparativaGerencial_Controller = function (ScreenService, General, GeneralServices) {

    /*global moment, getLocalVar, Configuration, angular*/
	this.setDefaultValues = function (widget) {
		
	    widget.getField('DTINTERVAL').defaultValue = {
	        formattedStart: moment().format('DD/MM/YYYY'),
	        start: moment().format('DD/MM/YYYY'),
	        formattedEnd: moment().format('DD/MM/YYYY'),
			end: moment().format('DD/MM/YYYY')
	    };

	    widget.applyDefaultValue();
	    
	    widget.getField('NMTIPOCUSTOPLAN').reload().then(callback => {
	    	let typeOfCost = callback.dataset.type_cost_lang;
	    	
	    	if(typeOfCost && typeOfCost.length){
	    		let currentTypeOfCost = typeOfCost[0];
	    			
	    		widget.currentRow.NMTIPOCUSTOPLAN = currentTypeOfCost.NMTIPOCUSTO;
	    		widget.currentRow.CDTIPOCUSTOPLAN = currentTypeOfCost.CDTIPOCUSTO; 
	    		
	    		widget.currentRow.NMTIPOCUSTOREAL = currentTypeOfCost.NMTIPOCUSTO;
	    		widget.currentRow.CDTIPOCUSTOREAL = currentTypeOfCost.CDTIPOCUSTO; 
	    		
	    	}
	    });
	    
	    let defaultReportValue = widget.getField('REPORT_NAME').dataSource.data[0].code;
		widget.currentRow.REPORT_NAME = defaultReportValue;
	};

	this.setRelatorio = function (widget) {
	    widget.getField('DTBASECUSTO').dataSource.data = [
			{
				"label": " de Referência",
				"value": "REF"
			},
			{
				"label": " do Cardápio",
				"value": "CAR"
			}
		];

		if (widget.currentRow.CDREPORT == 'CUS09908') {
			widget.getField('DTBASECUSTO').dataSource.data.push(
				{
					"label": " do Custo",
					"value": "CUS"
				}
			);
			widget.getField('DTCUSTO').isVisible = true;
		} else {
			widget.getField('DTCUSTO').isVisible = false;
		}

		widget.currentRow.DTBASECUSTO = "REF";
		widget.getField('DTBASECUSTO').reload();
	};

	this.filtraFiliais = function (widget) {
	    let cdgrupfili = 'T';

	    widget.getField('NMFILIAL').applyDefaultValue();
		widget.getField('NMSERVICO').applyDefaultValue();

		if (widget.getField('NMGRUPFILI').value()) {
			cdgrupfili = widget.currentRow.CDGRUPFILI;
		} else {
			widget.currentRow.CDGRUPFILI = 'T';
		}
		
		widget.getField('NMFILIAL').dataSourceFilter = [
		    {
		        "name": "CDGRUPFILI",
		        "operator": "=",
		        "value": cdgrupfili ? cdgrupfili : 'T'
		    },
		    {
		        "name": "CDOPERADOR",
		        "operator": "=",
		        "value": getLocalVar('CDOPERADOR')
		    }
	    ];
		widget.getField('NMFILIAL').reload();
		
		widget.getField('NMSERVICO').dataSourceFilter = [
			{
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": 'T'
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
		];
		widget.getField('NMSERVICO').reload();
	};

	this.filtraServicos = function (widget) {
	    widget.getField('NMSERVICO').dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.getField('ALLNMFILIAL').checked ? 'T' : widget.currentRow.NMFILIAL.join('_')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

		widget.getField('NMSERVICO').clearValue();
		widget.getField('NMSERVICO').reload();
	};

	this.setDtBaseCusto = function (widget) {
		if (widget.currentRow.DTBASECUSTO == 'CUS') {
			widget.getField('DTCUSTO').readOnly = false;
			widget.getField('DTCUSTO').validations.required = true;
		} else {
			widget.getField('DTCUSTO').value('');
			widget.getField('DTCUSTO').readOnly = true;
			widget.getField('DTCUSTO').validations = {};
		}
	};

	var validaProduto = function (prodIni, prodFin) {
		if (General.comparaPratoProduto(prodIni, prodFin, getLocalVar('CDPICTPROD'))) {
			return true;
		} else {
			ScreenService.showMessage("Produto inicial deve ser menor ou igual ao produto final.", 'error');
		}
	};

	var montaLista = function (widget, fieldName) {
		if (widget.getField('ALL' + fieldName).checked) {
			return 'T';
		} else {
			let row = widget.currentRow[fieldName];

			if (Array.isArray(row)) {
				return row.join('_');
			}
		}
	};

	var getTamNivelProduto = function (level) {
		let levels = General.getLevelByMask('CDPICTPROD', 1);

		if (level === 0) {
			return 0;
		} else {
			return levels[level - 1].caracteres;
		}
	};

	this.report = function (widget) {
		let reportFormats = [
		    {
		        name: "pdf",
		        value: "PDF"
		    },
		    {
		        name: "xlsx",
		        value: "XLSX"
		    }
		];

		if (widget.isValid()) {
			if (validaProduto(widget.currentRow.CDARVPRODINI, widget.currentRow.CDARVPRODFIN)) {
				widget.currentRow.DTINICIAL = widget.currentRow.DTINTERVAL.start;
				widget.currentRow.DTFINAL = widget.currentRow.DTINTERVAL.end;
				widget.currentRow.LFILIAL = montaLista(widget, 'NMFILIAL');
				widget.currentRow.LTIPOPRAT = montaLista(widget, 'NMTIPOPRAT');
				widget.currentRow.LSERVICO = montaLista(widget, 'NMSERVICO');
				widget.currentRow.NRTAMACNIVEL = getTamNivelProduto(widget.currentRow.NVORDENA);
				widget.currentRow.PERINICIAL = widget.currentRow.DTINICIAL;
				widget.currentRow.PERFINAL = widget.currentRow.DTFINAL;
				widget.currentRow.DTMESINIC = moment(widget.currentRow.DTINICIAL, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
				widget.currentRow.DTMESFINA = moment(widget.currentRow.DTFINAL, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

				switch (widget.currentRow.DTBASECUSTO) {
					case 'REF':
						widget.currentRow.IDDTCALC = 'S';
						widget.currentRow.DATACALC = 'S';
						break;

					case 'CAR':
						widget.currentRow.IDDTCALC = 'N';
						widget.currentRow.DATACALC = 'N';
						break;
					case 'CUS':
						widget.currentRow.IDDTCALC = 'D';
						widget.currentRow.DATACALC = 'D';
						break;
				}
				widget.currentRow.NRORG = getLocalVar('NRORG');
				widget.currentRow.CDPICTPROD = "!" + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
				widget.currentRow.CDPICTPRAT = "!" + getLocalVar('CDPICTPRAT').replace(/[^(/\.|\ )]/g, "@");
				General.openReportPopup(widget, this.confirmReport, [widget.currentRow], reportFormats);
			}
		}
	};

	this.confirmReport = function (row) {
		General.openReport('cus_relatorio#/cus09900_analise_comparativa_gerencial', row.REPORT_NAME, row);
	};
	
    this.bindOutDataCurrentRow = function(field){
        let widget  = field.widget;
        let outData = field._outData;

        if(outData){
            Object.keys(outData).forEach(function(property){
                widget.currentRow[outData[property]] = outData[property] === field.name ? 
                    widget.currentRow[outData[property]] : widget.currentRow[property];
            });
        }
        
        if(widget.currentRow.NMPRODUTOFIN === ''){
			if(field.name === 'NMPRODUTOINI'){
        	widget.currentRow.NMPRODUTOFIN = angular.copy(widget.currentRow.NMPRODUTOINI);
        	widget.currentRow.CDPRODUTOFIN = angular.copy(widget.currentRow.CDPRODUTOINI);
        	widget.currentRow.CDARVPRODFIN = angular.copy(widget.currentRow.CDARVPRODINI);
        	}
        }
    };
    
    this.onChangeCheckbox = function(args){
    	let widget = args.owner.field.widget;
    	let cRow = widget.currentRow;
    	if(args.owner.field.name == 'ALLNMFILIAL'){
	    	if(cRow.ALLNMFILIAL == 'T') {
	    		this.setReadOnlyOnField('NMFILIAL', true, widget);
	            this.setRequiredField('NMFILIAL', false, widget);
	            cRow.NMFILIAL = [];
	    	 } else {
	            this.setReadOnlyOnField('NMFILIAL', false, widget);
	            this.setRequiredField('NMFILIAL', true, widget);
	        }
	        widget.getField('ALLNMFILIAL').reload();
	        this.filtraServicos(widget);
    	} else {
    		if(cRow.ALLNMSERVICO == 'T') {
	    		this.setReadOnlyOnField('NMSERVICO', true, widget);
	            this.setRequiredField('NMSERVICO', false, widget);
	            cRow.NMSERVICO = [];
	    	 } else {
	            this.setReadOnlyOnField('NMSERVICO', false, widget);
	            this.setRequiredField('NMSERVICO', true, widget);
	        }
	        widget.getField('ALLNMSERVICO').reload();
    	}
    };
    
    this.setReadOnlyOnField = function (field, state, fieldWidget) {
        if (typeof field == "string") {
            field = fieldWidget.getField(field);
        }
        field.readOnly = state;
    };
    
    this.setRequiredField = function (field, state, fieldWidget) {
        if (typeof field == "string") {
            field = fieldWidget.getField(field);
        }

        if (state) {

            if (field.validations) {
                field.validations.required = true;
            } else {
                field.validations = {
                    required: true
                };
            }

        } else {
            delete field.validations.required;
        }
    };
    
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus09900_AnaliseComparativaGerencial_Controller', Cus09900_AnaliseComparativaGerencial_Controller);
});